
wm title . "Tk Theme Demo"
tk appname "Tk Theme Demo"

option add *highlightThickness 1
option add *highlightColor black
option add *highlightBackground black
option add *activeBackground #b0a090
option add *background #b0b0b0
option add *foreground black
option add *borderWidth 2
option add *relief raised
option add *font -*-lucidatypewriter-medium-*-*-*-12-*-*-*-*-*-*-*

option add *Frame.background #909090
option add *Frame.borderWidth 1
option add *Frame.highlightThickness 0

option add *Button.padX 1
option add *Button.padY 1

option add *Label.padX 1
option add *Label.padY 1

option add *Menu.padX 1
option add *Menu.padY 1
option add *Menu.borderWidth 1

option add *Menubutton.padX 1
option add *Menubutton.padY 2

option add *ThemeLabel.foreground white
option add *ThemeLabel.font "Times 12 bold"

proc theme:loadXPM {win f} {
	set xpmIn [open $f r]
	fconfigure $xpmIn -translation binary
	set xpmData [read $xpmIn]
	close $xpmIn

	$win $xpmData
}

proc theme:loadNew {themeWin win} {
	set sel [$win curselection]
	set f [$win get $sel]
	theme:loadXPM $themeWin $f
}

proc about {} {
	tk_dialog .about "About the Tk Theme Demo" "Copyright 2002 George Peter Staplin" info 0 OK
}

proc winPuts {win} {
	if {![winfo exists $win]} {
		return
	}
	puts [format %ld [winfo id $win]]
}


proc theme:frame:addUp {win type} {
	set p [winfo $type $win]
	set aWin [winfo parent $win]
	while {[winfo toplevel $aWin] != $aWin} {
		set p [expr {$p + [winfo $type $aWin]}]
		set aWin [winfo parent $aWin]
	}
	return $p
}

proc theme:frame:findMax {winList type} {
	set max 1
	foreach win $winList {
		set rWidth [winfo $type $win]
		if {$rWidth > $max} {
			set max $rWidth
		}
	}
	return $max
}

proc theme:menu:showFrame {menuAr win} {
	set x [theme:frame:addUp $win x] 
	set y [expr {[theme:frame:addUp $win y] + [winfo height $win]}]
	
	set newWin [theme:menu:getTop $win]
	
	theme:frame:translucent $newWin black
	
	option add *ThemeLabel*foreground white
	foreach {path data} $menuAr {
		foreach {theText cmd} $data break
	
		pack [theme:label $newWin.$path -text $theText] -fill x -padx 2
		bind $newWin.$path <ButtonPress-1> [list theme:menu:doAction $newWin $cmd]
	}
	option add *ThemeLabel*foreground white
	
	place $newWin -x $x -y $y
}

proc theme:menu:doAction {winToDestroy cmd} {
	destroy $winToDestroy

	eval $cmd
}
	
proc theme:menu:getTop {win} {
	set top [winfo toplevel $win]
	if {$top != "."} {
		append top "."
	}
	return "${top}tran"
}
	
proc theme:menu:event:ButtonPress-1 {menuAr win} {
	set top [theme:menu:getTop $win]
	if {[winfo exists $top]} {
		destroy [theme:menu:getTop $win]
		return
	}
	after idle [list theme:menu:showFrame $menuAr $win]
}

proc theme:menu {win menuAr args} {
	set opt(-text) "nil"
	array set opt $args
	
	pack [button $win -text $opt(-text) -command [list theme:menu:event:ButtonPress-1 $menuAr $win]]
	return $win
}

set hello ABC
set def(k) 123
proc main {} {

	tk_focusFollowsMouse

	pack [theme:frame .f] -fill both -expand 1 -side top
	theme:loadXPM .f circle_weave.xpm

	frame .f.menubar
	pack [menubutton .f.menubar.file -text File -underline 0 -menu .f.menubar.file.menu] -side left
	set fmenu [menu .f.menubar.file.menu -tearoff 0]
	$fmenu add command -label "Set variable ::hello to ABC 456" -command {set ::hello "ABC 456"}
	$fmenu add command -label "Set variable ::def(k) to DEF 123" -command {set ::def(k) "DEF 123"}
	#$fmenu add command -label "Translucent Test" -command {trans_test .f}
	$fmenu add command -label Exit -command exit

	pack [menubutton .f.menubar.about -text About -underline 0 -menu .f.menubar.about.menu] -side left
	set amenu [menu .f.menubar.about.menu -tearoff 0]
	$amenu add command -label About -command about
	#$amenu config 


	set menuAr(hello) [list "Hello World" {puts "Hello World"}]
	set menuAr(wonder) [list "I wonder..." {puts "wonderment..."}]
	set menuAr(speak) [list "Say something!" {puts "Why oh why must coding be so hard..."}]

	pack [theme:menu .f.menubar.tm [array get menuAr] -text Tran] -side left
	#pack [button .f.menubar.translucent -text Translucent -command "translucent_test .f.menubar.translucent"] -side left
	
	theme:frame .f.rel 
	#pack [theme:label .f.rel.l -text "Relativity:"] -side left
	pack [theme:label .f.rel.l -textvariable ::hello] -side left
	pack [theme:label .f.rel.l2 -textvariable ::def(k)] -side left
	
	#.f.rel.l "Relativity: "
	pack [scale .f.rel.s -orient horizontal] -side left
	.f.rel.s set 50
	
	theme:frame .f.con
	pack [theme:frame .f.con.fl] -side left
	pack [theme:label .f.con.fl.myconf] -side left
	.f.con.fl.myconf "My Confidence: "
	pack [scale .f.con.fl.s -orient horizontal] -side left
	.f.con.fl.s set 65
	
	pack [theme:frame .f.con.fr] -side right
	pack [theme:label .f.con.fr.yourconf] -side left
	.f.con.fr.yourconf "Your Confidence: "
	pack [scale .f.con.fr.s -orient horizontal] -side left
	.f.con.fr.s set 85
	
	theme:frame .f.h
	pack [theme:label .f.h.l] -side left
	.f.h.l "Warning: "
	pack [button .f.h.b -text "Drop Bomb!" -command {puts OUCH; set ::hello [clock clicks]; set ::def(k) [clock seconds]}] -side left

	theme:frame .f.t
	pack [theme:label .f.t.l]
	.f.t.l "Type Here:"
	pack [text .f.t.t -width 12 -height 3 -fg green -bg royalblue]
	pack [theme:label .f.t.l2]
	.f.t.l2 "And Here:"
	pack [entry .f.t.e -width 12]
	
	theme:label .f.uni
	#A spice of Unicode
	.f.uni "Unicode in a theme:label: \u0100 \u0101 \u0102 \u0103 \u0104"

	theme:frame .f.fsl
	pack [theme:label .f.fsl.l]
	.f.fsl.l "Select a Theme:"
	
	pack [listbox .f.fsl.list]

	foreach f [lsort -dictionary [glob *.xpm]] {
		.f.fsl.list insert end $f
	}

	bind .f.fsl.list <ButtonRelease-1> "theme:loadNew .f %W"

	pack .f.menubar -side top -anchor w
	pack .f.rel -side top -anchor w
	
	pack .f.h -side top -padx 5 -pady 5 -anchor w

	pack .f.con -side top -padx 20 -pady 20 -anchor c
	
	pack .f.uni
	pack .f.t
	pack .f.fsl -side bottom -pady 10

	set fi [open cursor.xpm r]
	#set fi [open 3D_Cursor-4_mod.xpm r]
	fconfigure $fi -translation binary
	set theData [read $fi]
	close $fi

	bind all <ButtonPress-1> {winPuts %W}
	
	#update idletasks
	
	#theme:cursor .f $theData
	#pack [frame .t] -side top -fill x
	#pack [scale .t.s -orient horizontal] -pady 10
	#theme:cursor .t $theData

	#theme:cursor .f.rel.l $theData
	#theme:cursor .f.rel $theData
	#theme:cursor .f.con $theData
	#pack [button .dest -text Destroy -command {destroy .f.h}]
}
main
